Exit:
        ld sp,(INIT_SP)
;        call RELOC_INSTALL      ; Make sure the relocation code is in place
        res 7,(IY+$14)          ; Restore default setting
        set 1,(IY+$0D)          ; Restore default setting
;		call RecreateTemp
;		jp Terminate
;		pop hl
		call TEMPS_CLEAR2		; Zero out the data overwritten by the map buffer
		bcall(_DelRes)
		bcall(_GRReset)			; Reset to acceptable values the graphing variables
		bcall(_ZeroFinanceVars)	; Same thing with the finance variables (they follow the graphing variables in RAM)
		jp Wrap_It_Up



;RelocRoutines:
;adj = RELOCADDR-RelocRoutines
;DeleteTemp =$+adj
;        call DeRelocate
;		ROM_CALL(3620h-1Ah)
;        jr Relocate
;RecreateTemp =$+adj
;		call DeRelocate
;        ROM_CALL(38EAh-1Ah)
;Relocate:
;        xor a
;        jr DoDeRelocate
;DeRelocate =$+adj
;        ld a,1
;DoDeRelocate:
;        push hl
;        push af
;		ld hl,VarName
;		rst 20h
;		ROM_CALL(213Eh-1Ah)
;        inc de
;        inc de
;        ex de,hl
;        pop bc
;DoTerminate:
;        ld de,StartAddr
;        sbc hl,de
;        rla
;        add hl,de
;        xor b
;        ld bc,ProgSize
;        rra
;        jr nc,DoReloc
;        add hl,bc
;        ld de,StartAddr+ProgSize-1
;ReverseSwapBytes:
;        dec hl
;	ld a,(de)
;        ldd
;        inc hl
;	ld (hl),a
;	ld a,b
;	or c
;        jr nz,ReverseSwapBytes
;        pop hl
;	ret
;SwapBytez =$+adj
;        push hl
;DoReloc:
;	ld a,(de)
;	ldi
;	dec hl
;	ld (hl),a
;	inc hl
;	ld a,b
;	or c
;	jr nz,DoReloc
;        pop hl
;	ret

;Terminate =$+adj
;        call DeRelocate
;        pop hl
;        push hl
;        jr DoTerminate

;CreateVar =$+adj
;        push hl
;        push de
;        call DeRelocate
;        pop hl
;        rst 20h
;        pop hl
;		ROM_CALL(23B1h-1Ah)             ;_CREATEPRGM
;        ld (hl),6       ;lock prgm
;        push de
;        call Relocate+adj
;        pop de
;        ret

;InsertMem =$+adj
; push hl
; push de
; push hl
; call DeRelocate
; ld hl,LVarName
; rst 20h
; ROM_CALL(213Eh-1Ah)
; pop bc
; push de
; ex de,hl ;hl = size
; call LD_HL_MHL
; add hl,bc
; ex de,hl
; pop hl
; ld (hl),e
; inc hl
; ld (hl),d
; dec hl
; pop de     ;# of bytes to offset
; add hl,de
; ex de,hl
; pop hl
; ROM_CALL($2272-1Ah)
; jp Relocate+adj

;DelMem =$+adj
; push hl
; push de

; push hl
; call DeRelocate
; ld hl,LVarName
; rst 20h
; ROM_CALL(213Eh-1Ah)
; pop bc

; push de
; ex de,hl ;hl = size
; call LD_HL_MHL
; or a
; sbc hl,bc
; ex de,hl
; pop hl

; ld (hl),e
; inc hl
; ld (hl),d
; dec hl
; pop de     
; add hl,de  ;hl = location
; pop de     ;de = # of bytes
; ROM_CALL($25A7-1Ah)
; jp Relocate+adj

;VarName =$+adj
;.db ProtProgObj,"ROBOTWAR",0
;.db 6,$DC,"Rw",0       ; Name of *this* program.  CASE-SENSITIVE!!!
                        ; **Name must appear as it does when loaded to calc...
                        ; ...not the PC

;RelocRoutinesSize = $-RelocRoutines


CreateWorldVar:         ;HL = size of var to create, NewVarName contains name
                        ; NewVarName must not be in program code.. should be
                        ; in APD_BUF or graphmem or similar
 bcall(_EnoughMem)		; check if enough space to create the save file
 ret c					; return if not
 push de				; EnoughMem returns de = size of program (bytes) to create
 ld hl,NewVarName		; where we stored the name of the file
 rst 20h				; _Mov9ToOP1, copy 9 bytes from (hl) to OP1
 pop hl					; hl = program size (in bytes)
 bcall(_CreateProg)		; requires: OP1 = pointer to name, hl = program size
 ld (hl),6				; lock prgm
 or a					; reset carry
 ret					; now DE = addr of variable and HL = addr of VAT entry


filename = $ + 1
.db ProgObj,"fileA",0

;# I don't think this is necessary for the 83/+
;RELOC_INSTALL:
; call APD_CLEAR
; ld hl,RelocRoutines
; ld de,RELOCADDR
; ld bc,RelocRoutinesSize
; ldir
; ret


INIT_SP:
.dw $0000