D_ZT_STR:
	bcall(_PutC)
	inc hl
	ld a,(hl)
	or a
	jr nz,D_ZT_STR
	ret

;ionRandom must return from 0-127
RAND:
	push	hl
	push	de
	push	bc
;	ld b,127	ld	hl,(randData)
	ld	hl, ($FE8D)
	ld	a, r
	ld	d, a
	ld	e, (hl)
	add	hl, de
	add	a, l
	xor	h
	ld	($FE8D), a
;	sbc	hl,hl
;	ld	e, a
;	ld	d, h
iRandomLp:
;	add	hl, de
;	djnz	iRandomLp
;	ld a,h
	rra
	pop bc
	pop	de
	pop	hl
	ret

GET_KEY:
	bcall(_GetCSC)
	ret

LD_HL_MHL:
	ld a,(hl) \ inc hl \ ld h,(hl) \ ld l,a
	ret

;ionFastCopy
fastCopy:				; equated as "CR_GRBCopy"
	push bc
	push de
	push hl
	push af
;	di
	ld	a,$80			; 7
	out	($10),a			; 11
	ld	hl,gbuf-12-(-(12*64)+1)		; 10
	ld	a,$20			; 7
	ld	c,a				; 4
	inc	hl				; 6 waste
	dec	hl				; 6 waste
fastCopyAgain:
	ld	b,64			; 7
	inc	c				; 4
	ld	de,-(12*64)+1	; 10
	out	($10),a			; 11
	add	hl,de			; 11
	ld	de,10			; 10
fastCopyLoop:
	add	hl,de			; 11
	inc	hl				; 6 waste
	inc	hl				; 6 waste
	inc	de				; 6
	ld	a,(hl)			; 7
	out	($11),a			; 11
	dec	de				; 6
	djnz	fastCopyLoop	; 13/8
	ld	a,c				; 4
	cp	$2B+1			; 7
	jr	nz,fastCopyAgain	; 10/1
;	ei					; in parts of the game we have "halts"
	pop af
	pop hl
	pop de
	pop bc
	ret					; 10



CP_HL_DE:
	push hl
	or a
	sbc hl,de
	pop hl
	ret

CP_HL_BC:
	push hl
	or a
	sbc hl,bc
	pop hl
	ret
	






G_NONE   = $00
G_DOWN   = $01
G_LEFT   = $02
G_RIGHT  = $03
G_RIGTH  = $03 ; Included because author of ASH couldn't spell :)
G_UP     = $04
G_ENTER  = $09
G_PLUS   = $0A
G_MINUS  = $0B
G_TIMES  = $0C
G_DIV    = $0D
G_CARROT = $0E
G_CLEAR  = $0F
G_NEG    = $11
G_3      = $12
G_6      = $13
G_9      = $14
G_PARENR = $15
G_TAN    = $16
G_VARS   = $17
G_PERIOD = $19
G_2      = $1A
G_5      = $1B
G_8      = $1C
G_PARENL = $1D
G_COS    = $1E
G_PRGM   = $1F
G_STAT   = $20
G_0      = $21
G_1      = $22
G_4      = $23
G_7      = $24
G_COMMA  = $25
G_SIN    = $26
G_MATRIX = $27
G_XTO    = $28
G_ON     = $29
G_STO    = $2A
G_LN     = $2B
G_LOG    = $2C
G_SQR    = $2D
G_INVE   = $2E
G_MATH   = $2F
G_ALPHA  = $30
G_GRAPH  = $31
G_TRACE  = $32
G_ZOOM   = $33
G_WINDOW = $34
G_YEDIT  = $35
G_2ND    = $36
G_MODE   = $37
G_DEL    = $38
